This mod lets you replace pretty much any sound in the game with audio files by placing them in the folder BepInEx/plugins/CustomAudio.

The mod should support wav, mp3, and ogg files.

It has a config variable for adjusting music volume beyond the 60% cap the game seems to impose.


When you start the game with this mod, it will create the following folders in your main Valheim folder:

BepInEx\plugins\CustomAudio\Ambient
BepInEx\plugins\CustomAudio\Music
BepInEx\plugins\CustomAudio\SFX

If you place a wav file in any of these folders with the right file name (see below), it will replace that specific audio clip with your file.

If you place a list of clips in a folder with the right folder name (file names don't matter), it will replace the entire list of clips with your list.

Clips are selected from lists to be played at random, so you can get repeats of music or ambient sounds.

Here's an example of replacing an entire SFX list with a different list of wav files:

https://www.youtube.com/watch?v=R6onJ3cjEqk

Finding the Names

Sound Effects

Sound effects are too numerous to list. If you want to find a specific sound effect, you can turn on the config variable DumpInfo and look at the console when the effect is played (one exception to this is fireplace type sounds, see below).

The console will show things like:

[Info   : Unity Log] CustomAudio checking SFX: sfx_footstep, clip: Player_Footstep_Wood_Walk_M_08

Here the sound effect is called sfx_footstep and the clip is called Player_Footstep_Wood_Walk_M_08

So, if you want to replace the entire list of clips, create a folder:

BepInEx\plugins\CustomAudio\SFX\sfx_footstep

And fill it with whatever clips you like, names of files don't matter.

If you want to only replace this one clip, you must rename your file to the clip name:

BepInEx\plugins\CustomAudio\SFX\Player_Footstep_Wood_Walk_M_08.wav



Portal Sound

The sound an portal makes when you are close is changed by using

BepInEx\plugins\CustomAudio\SFX\portal.wav


Fireplace Sounds

There are five types of fireplace sounds that this mod replaces. They don't work the same way as ordinary sound effects. To replace them, use the following:

BepInEx\plugins\CustomAudio\SFX\groundtorch.wav
BepInEx\plugins\CustomAudio\SFX\walltorch.wav
BepInEx\plugins\CustomAudio\SFX\fire_pit.wav
BepInEx\plugins\CustomAudio\SFX\bonfire.wav
BepInEx\plugins\CustomAudio\SFX\hearth.wav


Music

Music tracks are sorted into lists based on context, but you can also replace individual tracks if you know the name (turning on the info dump should show the name when music starts).

You can either create a folder named after the list, or create a file named after the track.

So, to change the main menu music, for example, either:

1. Create a folder named:

BepInEx\plugins\CustomAudio\Music\menu

and fill it with one or more custom music file - file names don't matter.

2. Create a single file named

BepInEx\plugins\CustomAudio\MainMenu.wav

To get a list of vanilla music lists, type customaudio music into the game console (F5). If you type this while in game, it will also display a list of possible music lists for all the environments in the game.

Environment folders will override the vanilla folders for that environment. For example, creating a Music\RainDay folder should do something like override meadows when it's raining during the day (untested).


Ambient Sounds

Wind and ocean ambient sounds are fixed and can be replaced by adding files called wind and ocean in the Ambient folder, e.g.:

BepInEx\plugins\CustomAudio\Ambient\wind.wav
BepInEx\plugins\CustomAudio\Ambient\ocean.wav


Other ambient sounds are organized into biomes, and each biome has three lists, one ordinary list, one for day only, and one for night only.

You can either replace one of the three lists, or replace single clips by name.

To replace an entire list, create a subfolder in CustomAudio\Ambient named after the list (e.g. Forest, Forest_day, or Forest_night for forest ambient sounds), and fill it with one or more audio file - file names don't matter. E.g.:

BepInEx\plugins\CustomAudio\Ambient\Forest_day\

To replace a single ambient clip, change the name of your audio file to the name of the clip and place it in BepInEx\plugins\CustomAudio\Ambient\, e.g.:

BepInEx\plugins\CustomAudio\Ambient\Wind_LeavesBlow_NoWind_Loop.wav


Here is a list of ambient clips dumped to console:

Ambient list name: Forest
    Ambient tracks: (use Forest)
        track name: Wind_LeavesBlow_NoWind_Loop
        track name: Hit_Leaves01
        track name: Hit_Leaves02
        track name: Hit_Leaves03
        track name: Hit_Leaves04
        track name: Hit_Leaves05
        track name: Amb_WindBreeze_S_01
        track name: Amb_WindBreeze_S_02
        track name: Amb_WindBreeze_S_03
        track name: Amb_WindBreeze_S_04
        track name: Amb_WindBreeze_S_05
        track name: Amb_WindBreeze_S_06
    Ambient day tracks: (use Forest_day)
        track name: Amb_Birds_ForestPark
        track name: 03 Chaffinch
        track name: 15 Rookery, Nests Of Rookery, With N
        track name: 16 Sedge Warbler
        track name: 19 Coal Tits, Two Pairs Displaying T
        track name: 22 Whitethroat, Song, With Willow Wa
        track name: 23 Lesser Whitethroat
    Ambient night tracks: (use Forest_night)
        track name: 63 Animals, Owl
Ambient list name: Swamp
    Ambient tracks: (use Swamp)
        track name: GiantBeetle_Growl1
        track name: GiantBeetle_Growl2
        track name: Insect_Wings
        track name: Splash_Water_Small1
        track name: Splash_Water_Small2
        track name: Splash_Water_Small3
        track name: Splash_WaterEmerge02
        track name: Splash_WaterEmerge03
        track name: Splash_WaterEmerge04
        track name: Splash_WaterEmerge05
        track name: Underwater_WavePassby1
        track name: Underwater_WavePassby2
        track name: Underwater_WavePassby3
        track name: Underwater_WavePassby4
    Ambient day tracks: (use Swamp_day)
    Ambient night tracks: (use Swamp_night)
Ambient list name: SunkenCrypt
    Ambient tracks: (use SunkenCrypt)
        track name: Splash_Water_Small2
        track name: Splash_Water_Small1
        track name: Splash_Water_Small3
        track name: Splash_WaterEmerge02
        track name: Splash_WaterEmerge03
        track name: Splash_WaterEmerge04
        track name: Splash_WaterEmerge05
        track name: Underwater_WavePassby1
        track name: Underwater_WavePassby2
        track name: Underwater_WavePassby3
        track name: Underwater_WavePassby4
    Ambient day tracks: (use SunkenCrypt_day)
    Ambient night tracks: (use SunkenCrypt_night)
Ambient list name: Crypt
    Ambient tracks: (use Crypt)
        track name: Creak_EerieWoodCreak
        track name: Creak_EerieWoodCreak
        track name: Eerie_HauntedHouseCreak
        track name: Eerie_HauntingGhostFade1
        track name: Eerie_HauntingGhostFade2
        track name: Eerie_HauntingGhostFade3
        track name: Eerie_HauntingGhostFade4
        track name: Eerie_HauntingGhostFade5
        track name: Rock_Crack_Deep1
        track name: Rock_Crack_Deep2
        track name: Rock_DebrisFall1
        track name: Rock_DebrisFall2
        track name: Rock_DebrisFall3
    Ambient day tracks: (use Crypt_day)
    Ambient night tracks: (use Crypt_night)


Linked Folders

You can now link folders to use the same tracks multiple times. To do this create a txt file in a folder named after the folder with the tracks you want to use.

For example, if you want to use the SnowDay tracks for SnowNight as well, put all your tracks in Music\SnowDay and then create a file called Music\SnowNight\SnowDay.txt and SnowNight will use SnowDay's tracks.


Credits

This mod uses the script Wave Loader which is licensed under the MIT license.


Config

A config file BepInEx/config/aedenthorn.CustomAudio.cfg is created after running the game once with this mod).

You can adjust the config values by editing this file using a text editor or in-game using the Config Manager﻿.


Technical

To install this mod, the easiest way is to just use Vortex, the Nexus Mods mod manager. It should take care of all dependencies.

To install manually, place the dll file in the BepInEx/plugins folder. You will need BepInEx.

Code is at https://github.com/aedenthorn/ValheimMods.

﻿﻿If you want to complain or ask for help or help me test my mods, you can visit my Discord server﻿.

Click here for a list of all my mods for Valheim.